"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _umi() {
  const data = require("umi");

  _umi = function _umi() {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function _path() {
    return data;
  };

  return data;
}

var _getProviderContent = _interopRequireDefault(require("./utils/getProviderContent"));

var _getModelContent = _interopRequireDefault(require("./utils/getModelContent"));

var _getExportContent = _interopRequireDefault(require("./utils/getExportContent"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const winPath = _umi().utils.winPath,
      getFile = _umi().utils.getFile;

var _default = api => {
  // 注册 getInitialState 方法
  api.addRuntimePluginKey(() => 'getInitialState'); // Add provider to prevent render

  api.addRuntimePlugin(() => (0, _path().join)(__dirname, 'runtime'));
  api.onGenerateFiles(() => {
    var _getFile;

    api.writeTmpFile({
      path: (0, _path().join)(_constants.DIR_NAME, 'Provider.tsx'),
      content: _getProviderContent.default
    });
    const entryFile = (_getFile = getFile({
      base: api.paths.absSrcPath,
      type: 'javascript',
      fileNameWithoutExt: 'app'
    })) === null || _getFile === void 0 ? void 0 : _getFile.path;

    if (entryFile) {
      const relEntryFile = (0, _path().relative)(api.paths.cwd, entryFile);
      api.writeTmpFile({
        path: _constants.RELATIVE_MODEL_PATH,
        content: (0, _getModelContent.default)(relEntryFile)
      });
      api.writeTmpFile({
        path: _constants.RELATIVE_EXPORT_PATH,
        content: (0, _getExportContent.default)(_constants.RELATIVE_MODEL)
      });
    } else {
      api.logger.info('[@umijs/plugin-initial-state]: 检测到 @umijs/plugin-initial-state 插件已经开启，但是不存在 app.ts/js 入口文件。');
    }
  });
  api.addUmiExports(() => [{
    exportAll: true,
    source: `../${_constants.RELATIVE_EXPORT}`
  }]);
  api.register({
    key: 'addExtraModels',
    fn: () => [{
      absPath: winPath((0, _path().join)(api.paths.absTmpPath, _constants.RELATIVE_MODEL_PATH)),
      namespace: '@@initialState'
    }]
  });
};

exports.default = _default;